<?php
	/* 
	 *
	 * ssClient - ssServer - Screenshot viewer
	 * http://ssclient.mine.nu
	 *
	 * This requires that you have mysql server installed
	 * to ssServer's ss.cfg config file. 
	 * 
	 * Add and edit the following line to ss.cfg under [ssServer] section
	 * // Send information about shots to a mySQL server ip,port,user,password,db[,table]
	 * ShotInfoMySql=192.168.0.1,3306,username,password,database,shots_table
	 *
	 * Note: there is an unresolved bug with ssServer's mysql code. It is recommended 
	 * that ssServer is added to crontab (to rerun it after a crash) with ss.chkrun.
	 * See: ss.chkrun file. 
	 * 
	 * Note: The screenshot files must be within the filesystem as
	 * the webserver (and this .php file)
	 */	 		 
	 
	 /* Note you need to create the mysql table your self. Here is the 
	    command you can use to create the table */
	 /*
        CREATE TABLE `shots` (
          `name` varchar(255) default NULL,
          `hostname` varchar(255) default NULL,
          `wonid` varchar(100) default NULL,
          `time` datetime default NULL,
          `servername` varchar(255) default NULL,
          `gametype` int(11) default NULL,
          `clientversion` varchar(100) default NULL,
          `imagefile` varchar(255) default NULL,
          `thumbfile` varchar(255) default NULL,
          `width` int(11) default NULL,
          `height` int(11) default NULL,
          `size` int(11) default NULL,
          `compression` int(11) default NULL,
          `capturemethod` varchar(100) default NULL,
          `id` int(11) NOT NULL auto_increment,
          PRIMARY KEY  (`id`)
        ) TYPE=MyISAM; 	 
     */	 
     
	 
	// MYSQL_ADDR - The address of the mysql server
	define("MYSQL_ADDR", "192.168.0.1");
	
	// MYSQL_USER - The username to connect to the database as
	define("MYSQL_USER", "username");
	
	// MYSQL_PASS - The password for DB_USER
	define("MYSQL_PASS", "password");
	
	// MYSQL_DB - The name of the database 
	define("MYSQL_DB", "database");
	
	// MYSQL_TABLE - The name of the table in the database 
	define("MYSQL_TABLE", "shots");
	
	// MYSQL_PERSISTENT - Use persistent Mysql connection
	define("MYSQL_PERSISTENT", false);
	
	
	
	// SS_MAKETHUMBS - Create thumbernails for the shots
	//		   This requires GD 2.0 support with php
	define("SS_MAKETHUMBS", true);

	// SS_THUMBS_PREFIX - The prefix of thumbfile
	define("SS_PREFIX", '.tn-');

	// SS_WIDTH - Thumb width in pixels
	define("SS_WIDTH", 160);
	
	// SS_HEIGHT - Thumb height in pixels
	define("SS_HEIGHT", 120);

	// SS_FILEBASEDIR - The base directory of the website's screenshot folder
	//                  Note: See ImageDir+ImageFile in ss.cfg
	define("SS_FILEBASEDIR", "/var/www/html/screenshots/");
	
	// SS_WWWBASE - The base address of the screenshots on the website
	if (!$SS_WWWBASE)
	define("SS_WWWBASE", "/screenshots/");
	
	
	// SS_CLEAN - Remove mysql entries for screenshot files (.jpg) that 
	//            do not exist any more. "keep the DB tables clean"
	//            Note: Entries of files that are not under SS_FILEBASEDIR
	//                  will be removed.
	//            Note: Thumbfiles will also be removed
	define("SS_CLEAN", true);

	// SEARCH_LIMIT - To how many search results is one page limited
	define("SEARCH_LIMIT", 250);
	
	
	// PHPNUKE_MODULE	- Php nuke module name
	//			  If you are using this as php nuke module, set the name of the module here
	//define("PHPNUKE_MODULE", "shot");
	
	// Set language
	// 0 - english
	// 1 - finnish/suomi
	// ps. This setting can also be set outside this .php as global variable
	$lan = 0;			

	// Select appropriate language after these defines 
	// $text = $ENtexts;  or $texts = $FItexts;  or translate yourself :D (and send to me)
	$ENtexts = array(
		'welcome'=>'ssClient screen shots',
		'findbyname'=>'Find shot by name ',
		'findbyname_example'=>'<SMALL>use * for all images</SMALL>',
		'findbywonid'=>'Find shot by ID',
		'findbyserver'=>'Find shot by server',
		'findbydate'=>'Find shot by date, ',
		'findbydate_after'=>'after',
		'findbydate_before'=>'before',
		'findbydate_example'=>'<SMALL>(in example 2003-07-31)</SMALL>',
		'findbyip'=>'Find shot by IP',
		'resultformat'=>'Result format',
		'format_information'=>'Information and details',
		'format_thumb'=>'Thumbnail preview',
		'format_view'=>'Screenshot view',
		'order_primary'=>'Primarly order result by',
		'order_secondary'=>'Secondary order',
		'order_none'=>'-none-',
		'order_aname'=>'Name, Ascending',
		'order_dname'=>'Name, Decending',
		'order_atime'=>'Time, Ascending',
		'order_dtime'=>'Time, Decending',
		'order_dserver'=>'Server, Decending',
		'order_aserver'=>'Server, Ascending',
		'order_dwonid'=>'Unique ID, Decending ',
		'order_awonid'=>'Unique ID, Ascending',
		'resultcount'=>'Result count in one page',
		'submit'=>'Submit',

		'name'=>'Name',
		'wonid'=>'Unique ID',
		'time'=>'Time',
		'server'=>'Server',
		'link'=>'Link',
		'selflink'=>'Link to this image',
		'game'=>'Game',
		'hl'=>'Half-Life',
		'hl2'=>'Half-Life 2',
		'rtcw'=>'Wolfenstein',
		'q3'=>'Quake 3',
		'mohaa'=>'MOHAA',
		'bf'=>'Battlefield',
		'et'=>'Enemy Territory',
		'cod'=>'Call of Duty',
		'unknown'=>'unknown',
		'compression'=>'Compression',
		'size'=>'Size',
		'bytes'=>'bytes',
		'capturemethod'=>'Capture method',
		'version'=>'ssClient version',
		'image'=>'Image',
		'result'=>'result',
		'results'=>'results',
		'next'=>'Next',
		'nexts'=>'Next',
		'asnext'=>'Next',
		'asprevious'=>'Previous',
		'previous'=>'Previous',
		'previouses'=>'Previous',
		'newsearch'=>'New search',
		'on_server'=>' on '
	);

	$FItexts = array(
		'welcome'=>'ssClientin kuvakaappaukset',
		'findbyname'=>'Etsi nimell',
		'findbyname_example'=>'<SMALL>kirjoita * selatakseen kaikkia kuvia</SMALL>',
		'findbywonid'=>'Etsi ID:ll',
		'findbyserver'=>'Etsi serverin nimell',
		'findbydate'=>'Etsin pivn mukaan, ',
		'findbydate_after'=>'jlkeen',
		'findbydate_before'=>'ennen',
		'findbydate_example'=>'<SMALL>(esim 2003-07-31)</SMALL>',
		'findbyip'=>'Etsi IP:ll',
		'resultformat'=>'Tuloslistauksen muoto',
		'format_information'=>'Tiedot ja listaus',
		'format_thumb'=>'Esikatselu',
		'format_view'=>'Screenshot katselu',
		'order_primary'=>'Ensisijainen jrjestminen',
		'order_secondary'=>'Toissijainen jrjestminen',
		'order_none'=>'-ei jrjestmist-',
		'order_aname'=>'Nimen mukaan, nouseva jrjestys',
		'order_dname'=>'Nimen mukaan, laskeva jrjestys',
		'order_atime'=>'Ajan mukaan, nouseva jrjestys',
		'order_dtime'=>'Ajan mukaan, laskeva jrjestys',
		'order_dserver'=>'Serverin mukaan, nouseva jrjestys',
		'order_aserver'=>'Serverin mukaan, laskeva jrjestys',
		'order_dwonid'=>'ID:n mukaan, nouseva jrjestys',
		'order_awonid'=>'ID:n mukaan, laskeva jrjestys',
		'resultcount'=>'Tulosten lukumr sivua kohti',
		'submit'=>'Hae',

		'name'=>'Nimi',
		'wonid'=>'ID',
		'time'=>'Aika',
		'server'=>'Serveri',
		'link'=>'Linkki',
		'selflink'=>'Linkki thn kuvaan',
		'game'=>'Peli',
		'hl'=>'Half-Life',
		'hl2'=>'Half-Life 2',
		'rtcw'=>'Wolfenstein',
		'q3'=>'Quake 3',
		'mohaa'=>'MOHAA',
		'bf'=>'Battlefield',
		'et'=>'Enemy Territory',
		'cod'=>'Call of Duty',
		'unknown'=>'tuntematon',
		'compression'=>'pakkaus',
		'size'=>'koko',
		'bytes'=>'tavua',
		'capturemethod'=>'Kaappaus menetelm',
		'version'=>'ssClientin versio',
		'image'=>'Kuva',
		'result'=>'tulos',
		'results'=>'tulosta',
		'next'=>'Seuraava',
		'nexts'=>'Seuraavat',
		'previous'=>'Edellinen',
		'previouses'=>'Edelliset',
		'asnext'=>'Seuraavaksi',
		'asprevious'=>'Edellinen oli',
		'newsearch'=>'Uusi haku',
		'on_server'=>', '
	);
		
	// Select appropriate language
	$text = ($lan?$FItexts:$ENtexts);


	//////////////////////////////////////////////////////////////////////
	//                                                                  //
	//                    Do not edit after this line                   //
	//                (unless you know what you are doing)              //
	//                                                                  //
	//////////////////////////////////////////////////////////////////////

	//////////////////////////////////////////////////////////////////////
	//                    Some functions                                //
	//////////////////////////////////////////////////////////////////////

	/**
 	 * Creates parameterlist
 	 * @param $keye exception to this key
 	 * @param $value exception value to the key
 	 */
	function htmlMakeParams($key="", $value="", $key2="", $value2="", $key3="", $value3="", $key4="", $value4="") {
		$pars = $_GET;
		if (PHPNUKE_MODULE) 
			$pars['name'] = PHPNUKE_MODULE;
		if ($key)
			$pars[$key]=$value;
		if ($key2)
			$pars[$key2]=$value2;
		if ($key3)
			$pars[$key3]=$value3;
		if ($key4)
			$pars[$key4]=$value4;
		foreach ($pars as $k => $value)
			if ($value)
				$ret .= ($ret?"&":"?").$k."=".$value;
		if (!$ret)
			$ret = "?".$ret;
		return $ret;
	}
	
	/**
	 * Create params for a link to a specific shot
	 * @param $id the id of this shot
	 * @return the params
	 */
	function shotIdParams($id="")
	{	
		$pars = array('id'=>$id,'mode'=>'search','format'=>'view');
		if (PHPNUKE_MODULE) 
			$pars['name'] = PHPNUKE_MODULE;
		foreach ($pars as $k => $value)
			if ($value)
				$ret .= ($ret?"&":"?").$k."=".$value;
		if (!$ret)
			$ret = "?".$ret;
		return $ret;
	}
	
	/**
	 * Create params for a link to a specific shot
	 * @param $name the name of the user
	 * @return the params
	 */
	function shotNameParams($name="")
	{	
		$pars = array('playername'=>$name,'mode'=>'search','format'=>'thumb');	
		if (PHPNUKE_MODULE) 
			$pars['name'] = PHPNUKE_MODULE;
		foreach ($pars as $k => $value)
			if ($value)
				$ret .= ($ret?"&":"?").$k."=".$value;
		if (!$ret)
			$ret = "?".$ret;
		return $ret;
	}
	
	
	/**
	 * Create params for a link to a specific UniqueID
	 * @param $uid the name of the user
	 * @return the params
	 */
	function shotUIDParams($uid="", $ip="")
	{	
		if ($uid=="" && $ip!="")
			$pars = array('ip'=>$ip,'mode'=>'search','format'=>'thumb');	
		else
			$pars = array('wonid'=>$uid,'mode'=>'search','format'=>'thumb');	
		if (PHPNUKE_MODULE) 
			$pars['name'] = PHPNUKE_MODULE;
		foreach ($pars as $k => $value)
			if ($value)
				$ret .= ($ret?"&":"?").$k."=".$value;
		if (!$ret)
			$ret = "?".$ret;
		return $ret;
	}	

	/**
	 * Create params for a link to a specific server
	 * @param $server the name of the user
	 * @return the params
	 */
	function shotServerParams($name="")
	{	
		$pars = array('server'=>$name,'mode'=>'search','format'=>'thumb');
		if (PHPNUKE_MODULE) 
			$pars['name'] = PHPNUKE_MODULE;
		foreach ($pars as $k => $value)
			if ($value)
				$ret .= ($ret?"&":"?").$k."=".$value;
		if (!$ret)
			$ret = "?".$ret;
		return $ret;
	}
	
	
	
	/**
 	 * Creates html code for a line of table
 	 * @param the paragraphs 
 	 * @return The html code
 	 */
	function htmlTableLine()
	{
		$args = func_get_args();

		if ( func_num_args() <=0 ) 
			return "<tr></tr>";
		else
			return "<tr><td>".implode("</td><td>",$args)."</td><tr>";
	}
	
	/**
	 * Fixes filename
	 * @param $filename the filename string
	 */	
	function FixFileName($filename)
	{
		return str_replace("^" , "\^", $filename);
	}
	
	/**
	 * Make Thumbnail file from source image file
	 * @param $srcfile The file name of the source image 
	 * @param $dstfile The destination file
	 * @param $wid The width of thumb nail
	 * @param $hei The height of thumb nail
	 */
	function MakeThumbJPEG($srcfile, $dstfile, $wid, $hei) 
	{
		//$srcfile = FixFileName($srcfile);
		//$dstfile = FixFileName($dstfile);
		$img = imagecreatefromjpeg($srcfile);
		$img2= imagecreatetruecolor($wid, $hei);
		//$img2= imagecreate($wid, $hei);
		
		imagecopyresized($img2, $img, 0,0, 0,0, $wid, $hei, ImageSX($img),ImageSY($img) );
		imagejpeg($img2, ($dstfile));
		imagedestroy($img);
		imagedestroy($img2);
	}	

	//////////////////////////////////////////////////////////////////////
	//                    Search page                                   //
	//////////////////////////////////////////////////////////////////////

	$mode = $_GET['mode'];
	if (!$mode) $mode = 'index';	

	if (!$_GET['width']) $_GET['width'] = SS_WIDTH;
	if (!$_GET['height']) $_GET['height'] = SS_HEIGHT;
	if (!$_GET['count']) $_GET['count'] = 100;
	
	if (SEARCH_LIMIT) {
		if ($_GET['count'] > SEARCH_LIMIT) $_GET['count'] = SEARCH_LIMIT;
	}
	
	
	//////////////////////////////////////////////////////////////////////
	//                    The front page                                //
	//////////////////////////////////////////////////////////////////////
	if ( $mode == 'index' ) {
		echo '
			' . $text['welcome'] . '<BR />
			<FORM NAME="input" METHOD="get">

			' . $text['findbyname'] . '
			<INPUT TYPE="text" NAME="playername" VALUE="' . $_GET['playername'] . '"> ' . $text['findbyname_example'] . '<BR />

			' . $text['findbywonid'] . '
			<INPUT TYPE="text" NAME="wonid" VALUE="' . $_GET['wonid'] . '"><BR />

			' . $text['findbyserver'] . '
			<INPUT TYPE="text" NAME="server" VALUE="' . $_GET['server'] . '"><BR />
			
			' . $text['findbydate'] . $text['findbydate_after'] . '
			<INPUT TYPE="text" NAME="after" VALUE="' . $_GET['after'] . '">
			
			' . $text['findbydate_before'] . '
			<INPUT TYPE="text" NAME="before" VALUE="' . $_GET['before'] . '">
			
			' . $text['findbydate_example'] . '
			<BR />

			' . $text['findbyip'] . '
			<INPUT TYPE="text" NAME="ip" VALUE="' . $_GET['ip'] . '"><BR />

			<INPUT TYPE="hidden" NAME="mode" VALUE="search">

			' . $text['resultformat'] . '		
			<SELECT NAME="format">
				<OPTION VALUE="list"' . ($_GET['format']=='list'?" SELECTED":"") . '>' . $text['format_information'] . '
				<OPTION VALUE="thumb"' . ($_GET['format']=='thumb'?" SELECTED":"") . '>' . $text['format_thumb'] . '
				<OPTION VALUE="view"' . ($_GET['format']=='view'?" SELECTED":"") . '>' . $text['format_view'] . '
			</SELECT><BR />

			' . $text['order_primary'] . '
			<SELECT NAME="po">
				<OPTION VALUE=""' . (!$_GET['po']?" SELECTED":"") . '>' . $text['order_none'] . '
				<OPTION VALUE="dname"' . ($_GET['po']=='dname'?" SELECTED":"") . '>' . $text['order_dname'] . '
				<OPTION VALUE="aname"' . ($_GET['po']=='aname'?" SELECTED":"") . '>' . $text['order_aname'] . '
				<OPTION VALUE="dtime"' . ($_GET['po']=='dtime'?" SELECTED":"") . '>' . $text['order_dtime'] . '
				<OPTION VALUE="atime"' . ($_GET['po']=='atime'?" SELECTED":"") . '>' . $text['order_atime'] . '
				<OPTION VALUE="dserver"' . ($_GET['po']=='dserver'?" SELECTED":"") . '>' . $text['order_dserver'] . '
				<OPTION VALUE="aserver"' . ($_GET['po']=='aserver'?" SELECTED":"") . '>' . $text['order_aserver'] . '
				<OPTION VALUE="dwonid"' . ($_GET['po']=='dwonid'?" SELECTED":"") . '>' . $text['order_dwonid'] . '
				<OPTION VALUE="awonid"' . ($_GET['po']=='awonid'?" SELECTED":"") . '>' . $text['order_awonid'] . '
			</SELECT> 
			
			' . $text['order_secondary'] . '
			<SELECT NAME="so">
				<OPTION VALUE=""' . (!$_GET['so']?" SELECTED":"") . '>' . $text['order_none'] . '
				<OPTION VALUE="dname"' . ($_GET['so']=='dname'?" SELECTED":"") . '>' . $text['order_dname'] . '
				<OPTION VALUE="aname"' . ($_GET['so']=='aname'?" SELECTED":"") . '>' . $text['order_aname'] . '
				<OPTION VALUE="dtime"' . ($_GET['so']=='dtime'?" SELECTED":"") . '>' . $text['order_dtime'] . '
				<OPTION VALUE="atime"' . ($_GET['so']=='atime'?" SELECTED":"") . '>' . $text['order_atime'] . '
				<OPTION VALUE="dserver"' . ($_GET['so']=='dserver'?" SELECTED":"") . '>' . $text['order_dserver'] . '
				<OPTION VALUE="aserver"' . ($_GET['so']=='aserver'?" SELECTED":"") . '>' . $text['order_aserver'] . '
				<OPTION VALUE="dwonid"' . ($_GET['so']=='dwonid'?" SELECTED":"") . '>' . $text['order_dwonid'] . '
				<OPTION VALUE="awonid"' . ($_GET['so']=='awonid'?" SELECTED":"") . '>' . $text['order_awonid'] . '
			</SELECT> 

			<BR />

			' . $text['resultcount'] . '
			<SELECT NAME="count">
				<OPTION VALUE="10"' . ($_GET['count']=='10'?" SELECTED":"") . '>10
				<OPTION VALUE="25"' . ($_GET['count']=='25'?" SELECTED":"") . '>25
				<OPTION VALUE="50"' . ($_GET['count']=='50'?" SELECTED":"") . '>50
				<OPTION VALUE="100"' . ($_GET['count']=='100'?" SELECTED":"") . '>100
			</SELECT>
			
			
			<INPUT TYPE="hidden" NAME="width" VALUE="' . $_GET['width'] . '">
			<INPUT TYPE="hidden" NAME="height" VALUE="' . $_GET['height'] . '">
			' .
			(PHPNUKE_MODULE?'<INPUT TYPE="hidden" NAME="name" VALUE="' . PHPNUKE_MODULE . '">':'')
			.'

			<BR />
			<INPUT TYPE="submit" VALUE="' . $text['submit'] . '">

			</FORM> 		
						
		';
	}
	
	//////////////////////////////////////////////////////////////////////
	//                    Search result page                            //
	//////////////////////////////////////////////////////////////////////

	if ( $mode == 'search' ) {
		
		/* Connecting, selecting database */
		if (MYSQL_PERSISTENT) 
    			$link = mysql_pconnect(MYSQL_ADDR, MYSQL_USER, MYSQL_PASS)
        			or die("Failed to connect to mySQL server");
        	else
    			$link = mysql_connect(MYSQL_ADDR, MYSQL_USER, MYSQL_PASS)
        			or die("Failed to connect to mySQL server");
        	
    		mysql_select_db(MYSQL_DB) or die("Could not select database");
    		
    		/* Formatting query string */
    		$where = array();
    		

		if ($_GET['playername'])
    			$where[] = "name LIKE " . "'%" . str_replace("*", "%", addslashes($_GET['playername'])) . "%'";

    		if ($_GET['server'])
    			$where[] = "servername LIKE " . "'%" . str_replace("*", "%", addslashes($_GET['server'])) . "%'";
    			
    		if ($_GET['wonid'])
    			$where[] = "wonid LIKE " . "'%" . str_replace("*", "%", addslashes($_GET['wonid'])) . "%'";
    			
    		if ($_GET['ip'])
    			$where[]= "hostname LIKE '" . str_replace("*", "%", addslashes($_GET['ip'])) . "'";
    			
    		if ($_GET['after'])
    			$where[] = "time>'" . addslashes($_GET['after'])."'";
    			
    		if ($_GET['before'])
    			$where[]= "time<'" . addslashes($_GET['before'])."'";

    		if ($_GET['id'])
    			$where[] = "id=" . addslashes($_GET['id']);
    			
		$select = "name, hostname, wonid, time, servername, imagefile, thumbfile, id";
		if ($_GET['format'] == 'view')
			$select = "name, hostname, wonid, time, servername, imagefile, thumbfile, gametype, clientversion, size, compression, width, height, capturemethod, id";

    		
    		if ($_GET['count']) {
    			$querylimit = $_GET['count'];
    			$pageindex  = $_GET['pageindex'];
    			if (!$pageindex || $pageindex<0) $pageindex = 0; 
    			if ($_GET['format'] == 'view') {
    				if ($pageindex>0) {
    					$querylimit = 3;
    					$pageindex--;
    				} else {
    					$querylimit = 2;
    					$pageindex = 0;
    				}
    			}
    			$limit .= " LIMIT " . addslashes($pageindex) . "," . addslashes($querylimit);
    		}
    		
    		function orderString($param)
    		{
    			switch ($param) 
    			{
    				case "aname":return "name ASC";
    				case "dname":return "name DESC";
    				case "awonid":return "wonid ASC";
    				case "dwonid":return "wonid DESC";
    				case "aserver":return "servername ASC";
    				case "dserver":return "servername DESC";
    				case "atime":return "time ASC";
    				case "dtime":return "time DESC";
    			}
    			return NULL;
    		}
    		$order1 = orderString($_GET['po']);
    		$order2 = orderString($_GET['so']);

    		if ($order1 || $order2) {
    			if ($order1 && $order2) $order2 = ", ".$order2;
    			$order = ' ORDER BY '.$order1.$order2;	    			
    		}
       		$query = 'SELECT ' . $select . ' FROM ' . MYSQL_TABLE .     			
    			' WHERE ' . implode(" AND ",$where) . 
       			$order . 
    			$limit . 
    			";";
    		
		$result = mysql_query($query) or die("mySQL Query failed");
		
		$validcount = 0; 	// The count of valid shots
		$images = array();
		while ($images[] = mysql_fetch_assoc($result));
		reset( $images );
		
		///////////////////////////////////////////////////////////////
		//        Checking if image entries are still valid.         //
		///////////////////////////////////////////////////////////////
		//while ($image = next( $images ) ) {
		for ($i= count($images)-1; $i>=0; $i--) {
			$image = &$images[ $i ];
			if (!$image) continue;
			
    			$filename = $image['imagefile'];
    			$thumbfile = $image['thumbfile'];
    			$deletefile = false;
    			

    			// is the file is missing
    			if (!file_exists($filename))
    			{
				// This file is missing, so it will be removed
				echo("File " . $filename . " is missing. <BR />");
    				$deletefile = true;
    			} else
    				
    			// Check wheather this file is under www root
    			if (strncmp($filename, SS_FILEBASEDIR, strlen(SS_FILEBASEDIR)) != 0)
    			{
				// This file entry is not under SS_FILEBASEDIR, so it will be removed
				echo("File " . $filename . " not under SS_FILEBASEDIR <BR />");
    				$deletefile = true;
    			}   			
    			
    			if ($deletefile && SS_CLEAN)
    			{
				$query = "DELETE FROM " . MYSQL_TABLE . " WHERE id=" . addslashes($image['id']) . ";";
				if (!mysql_query($query)) echo("Failed to remove entry for shot id=" . addslashes($image['id']) . "<BR />");
				
				if ($thumbfile && file_exists($thumbfile)) {
					if (!unlink($thumbfile))
						echo 'failed to delete thumbfile ' . $thumbfile . "<BR />";
				}
				
				unset( $images[ $i ] );
				continue;
    			}
    			
    			// if thumb file has been deleted, set the field null
    			if (SS_CLEAN && $thumbfile && !file_exists($thumbfile))
    			{
    				$image['thumbfile'] = NULL;
    				$query = "UPDATE " . MYSQL_TABLE . " SET thumbfile='' WHERE id=" . addslashes($image['id']) . ";";
				if (!mysql_query($query)) echo("Failed to nullify thumbfile field of missing file ' . $thumbfile . ' of a shot with id=" . $image['id'] . "<BR />");
				$thumbfile = '';
    			}
    			
    			// Create new thumb file if necessary
    			if (SS_MAKETHUMBS && !$thumbfile ) 
    			{
    				 // Determine the new filename
    				 $thumbfile = dirname($filename) . '/' . SS_PREFIX . basename($filename);
    				 
    				 // Create Thumbnail image file
    				 MakeThumbJPEG($filename, $thumbfile, SS_WIDTH, SS_HEIGHT);
    				 
    				 // Update mysql field
    				$query = "UPDATE " . MYSQL_TABLE . " SET thumbfile='" . $thumbfile . "' WHERE id=" . addslashes($image['id']) . ";";
				if (!mysql_query($query)) echo("Failed to set thumbfile ' . $thumbfile . ' of a shot with id=" . $image['id'] . "<BR />");

				// Determine thumb url name
    				$image['thumbfile'] = $thumbfile;
    				$image['thumburl'] = SS_WWWBASE . substr( $thumbfile, strlen(SS_FILEBASEDIR) );
    			} 
    			
    			// Thumb file exists, create link to it
    			else if ($thumbfile && file_exists($thumbfile))
    			{
    				$image['thumburl'] = SS_WWWBASE . substr( $thumbfile, strlen(SS_FILEBASEDIR) );
    			}

   			$image['url'] = SS_WWWBASE . substr( $filename, strlen(SS_FILEBASEDIR) );
   			
    			$image['imagetext'] = $image['name'] . $text['on_server'] . $image['servername'] . " " . $image['time'];
    				
    			$validcount++;
    		}
		reset( $images );

		
		///////////////////////////////////////////////////////////////
		//                 Formatting result in list format          //
		///////////////////////////////////////////////////////////////
		if ($_GET['format'] == 'list')
		{
			if ($validcount != 0) {
				echo "<TABLE>";
				echo htmlTableLine(
				'<A HREF="' . htmlMakeParams('po', ($_GET['po']=='dname'?'aname':'dname'), 'so', ( $_GET['po']=='dname'||$_GET['po']=='aname'?$_GET['so']:$_GET['po']) ) . '"><B>' . $text['name'] . '</B></A>',
				'<A HREF="' . htmlMakeParams('po', ($_GET['po']=='dwonid'?'awonid':'dwonid'), 'so', ( $_GET['po']=='dwonid'||$_GET['po']=='awonid'?$_GET['so']:$_GET['po']) ) . '"><B>' . $text['wonid'] . '</B></A>',
				'<A HREF="' . htmlMakeParams('po', ($_GET['po']=='dtime'?'atime':'dtime'), 'so', ( $_GET['po']=='dtime'||$_GET['po']=='atime'?$_GET['so']:$_GET['po']) ) . '"><B>' . $text['time'] . '</B></A>',
				'<A HREF="' . htmlMakeParams('po', ($_GET['po']=='dserver'?'aserver':'dserver'), 'so', ( $_GET['po']=='dserver'||$_GET['po']=='aserver'?$_GET['so']:$_GET['po']) ) . '"><B>' . $text['server'] . '</B></A>',
				'<A HREF="' . htmlMakeParams() . '"><B>' . $text['link'] . '</B></A>'
				);

				$image = reset( $images );
				do 
    					echo htmlTableLine(
    						'<A HREF="' . shotNameParams($image['name']) . '" class="search">' . $image['name'] . '</A>',
    						'<A HREF="' . shotUIDParams($image['wonid'], $image['ip']) . '" class="search">' . $image['wonid'] . '</A>',
    						$image['time'], 
    						'<A HREF="' . shotServerParams($image['servername']) . '" class="search">' . $image['servername'] . '</A>',
    						'<A HREF="' . shotIdParams($image['id']) . '"><B>' . $text['image'] . '</B></A>' 
    					);
    				while ($image = next( $images ) );
				echo "</TABLE>";
			}
        	} else

		///////////////////////////////////////////////////////////////
		//                 Formatting result in thumbnails           //
		///////////////////////////////////////////////////////////////
		if ($_GET['format'] == 'thumb')
		{
			$i = 0;
			$image = reset( $images );
			do {
				echo '<A HREF="' . shotIdParams($image['id']) /* htmlMakeParams('format','view', 'pageindex', $_GET['pageindex']+$i) */ . '">';
    				echo '<IMG SRC="' . ($image['thumburl']?$image['thumburl']:$image['url']) . '" ALT="' . $image['imagetext'] . '" WIDTH=' . $_GET['width'] . ' HEIGHT=' . $_GET['height'] . '/>';
    				echo '</A>';
    				$i++;
			} while ($image = next( $images ) );
		} else 
		
		///////////////////////////////////////////////////////////////
		//                 Formatting result screenshot view         //
		///////////////////////////////////////////////////////////////
		if ($_GET['format'] == 'view')
		{
			if ( $querylimit == 3 ) 
			{
				$previmage = $images[0];
				$image = $images[1];
				$nextimage = $images[2];
			} else
			{
				$previmage = NULL;
				$image = $images[0];
				$nextimage = $images[1];
			}
			
			if ($image) 
			{
				echo "<TABLE>";
				if ($image['gametype'] == 1) $gametype = $text['hl'];
				else if ($image['gametype'] == 2) $gametype = $text['mohaa'];
				else if ($image['gametype'] == 3) $gametype = $text['bf'];
				else if ($image['gametype'] == 4) $gametype = $text['et'];
				else if ($image['gametype'] == 5) $gametype = $text['cod'];
				else if ($image['gametype'] == 6) $gametype = $text['q3'];
				else if ($image['gametype'] == 7) $gametype = $text['hl2'];
				else if ($image['gametype'] == 10) $gametype = $text['rtcw'];
				else $gametype = $text['unknown'];
				echo htmlTableLine(
					'<B>' . $text['name'] . ':</B>', '<A HREF="' . shotNameParams($image['name']) . '" class="search">'.$image['name'].'</A>', //$image['name'], 
					'<B>' . $text['server'] . ':</B>', '<A HREF="' . shotServerParams($image['servername']) . '" class="search">'.$image['servername'].'</A>'); //$image['servername']
				echo htmlTableLine(
					'<B>' . $text['wonid'] . ':</B>', '<A HREF="' . shotUIDParams($image['wonid'], $image['ip']) . '" class="search">' . $image['wonid'] . '</A>',//$image['wonid'], 
					'<B>' . $text['game'] . ':</B>', $gametype);
				echo htmlTableLine(
					'<B>' . $text['time'] . ':</B>', $image['time'], 
					'<B>' . $text['image'] . ':</B>', "" . $image['width'] . "x" . $image['height'] . ' ' . $text['compression'] . ': ' . $image['compression'] . "%" . ' ' . $text['size'] . ':' . $image['size'] . ' ' . $text['bytes']);
				echo htmlTableLine(
					'<B>' . $text['version'] . ':</B>', $image['clientversion'], 
					'<B>' . $text['capturemethod'] . ':</B>', $image['capturemethod']);
					
				//echo htmlTableLine('<B></B>', $image[''], '<B></B>', $image['']);
				//echo htmlTableLine('<B></B>', $image[''], '<B></B>', $image['']);
				echo "</TABLE>";
				echo '<A HREF="' . shotIdParams($image['id']) . '"><B><SPAN TITLE="This is ' . $image['imagetext'] . '">' . $text['selflink'] . '</SPAN></B></A><BR />';
			}
			
			if ( $previmage )
				echo '<A HREF="' . htmlMakeParams('pageindex',$_GET['pageindex'] - 1).'"><SPAN TITLE="' . $text['asprevious'] . ' ' . $previmage['imagetext'] . '">' . $text['previous'] . '</SPAN></A><SPAN> </SPAN>';
			
			if ( $nextimage )
				echo '<A HREF="' . htmlMakeParams('pageindex',$_GET['pageindex'] + 1) . '"><SPAN TITLE="' . $text['asnext'] . ' ' . $nextimage['imagetext'] . '">' . $text['next'] . '</SPAN></A>';
    				

			if ($image)
				echo '<BR /><IMG SRC="' . $image['url'] . '" ALT="' . $image['imagetext'] . '" /><BR />';

		} 		



		///////////////////////////////////////////////////////////////
		//                 Footer notes                              //
		///////////////////////////////////////////////////////////////		
		if ($_GET['format'] != 'view') {
			//$count = count($images);
    			$count = mysql_num_rows($result);
    			//$count = $resultcount;
			echo "<BR />" . $validcount . " " . ($validcount==1?$text['result']:$text['results']) ."<BR />";
		
    			if ($_GET['count']) {
				if ( $_GET['pageindex'] > 0 ) {
					echo '<A HREF="' . htmlMakeParams('pageindex',$_GET['pageindex'] - $_GET['count']).'">' . $text['previouses'] . ' ' . $_GET['count'] . ' ' . $text['results'] . '</A><BR />';
				}

				if ( $count >= $_GET['count'] ) {
					echo '<A HREF="' . htmlMakeParams('pageindex',$_GET['pageindex'] + $_GET['count']) . '">' . $text['nexts'] . ' ' . $_GET['count'] . ' ' . $text['results'] . '</A><BR />';
				}
			}
		}
				
		echo '<A HREF="' . htmlMakeParams('mode', 'index') . '">' . $text['newsearch'] . '</A>';
		mysql_free_result( $result );
		mysql_close();
	}
	

?>