(*
 This example script bans all players whose name begins
 with the letter A and remembers old bans

script.load ban_example scripts/ban_example.pas
script.ban_example.log.add console stdout
script.ban_example.log.add file log/banlog.log
script.ban_example.execute
*)
program ban_example;

const FILENAME = 'banned.cfg';

var banfile: TBanFile;

Procedure OnPlayer(Player: TGameClient);
var OldBan: TBan;
begin
    // ban player if it's name begins with A
    if (player.RealName[1]='A') or (player.RealName[1]='a') then begin
        Writeln('Banning '+player.RealName+' (ID: '+player.UniqueId+')');
        banfile.addid(player.UniqueId, 'We don''t want your kind in here!', player.RealName+' '+player.Variable.VarString[GC_IP]);
        banfile.save( filename );
    end;

    // See if the player has been banned before
    OldBan := banfile.FindById(player.UniqueId);
    if OldBan<>nil then begin
        player.KickMe('You are banned: '+oldBan.reason);
    end;
end;

Procedure OnGameServerStatus(Server: TGameServer);
var I:Integer;
    Player: TGameClient;
begin
    for I:=0 to server.count-1 do
        OnPlayer( Server.GameClient[I] );
end;

Procedure Initialization;
begin
    Writeln('Loading ban example');
    banfile := TBanFile.create;
    banfile.load( filename );
end;

Procedure Finalization;
begin
    Writeln('Unloading ban example');
    banfile.destroy;
end;

begin
end.
