unit GameClient;
interface
Uses
    ObjectNode,
    Variables;

Type
    TGameClientVariables = Class;
    TGameClient = class(TObjectLeaf)
        Property RealName: String Read FRealName Write FRealName;
        Property UniqueId: String Read FUniqueId Write SetUniqueId;
        Property UserId: Integer Read FUserId Write SetUserId;
        Property Variable: TGameClientVariables Read GetVar;
        Property ssClient: TObject Read FssClient Write FssClient;

        // Status iteration counter. This value is increased after every
        // successfull status command
        Property    StatusIndex: Integer Read FStatusIndex;
        // Run a trigger
        Procedure   RunTrigger(Trigger: String);
        // Is this client authed
        Function    IsAuthed: Boolean;
        // All help
        Function    Help: String; 
        Function    Settings: String; 
        Function    KickMe(Const Reason: String=''):String;
        // Execute a command
        Function    Run(Const Cmd, Params: TStringArray; ParamStr: String): string;
        Constructor Create;
        Destructor Destroy; 
    end;

    TGameClientVariables=Class(TVariable)
    end;

Const
    GC_NAME='Name';
    GC_UNIQUEID='UniqueId';
    GC_USERID='UserId';
    GC_INDEX='Index';
    GC_SCORE='Score';
    GC_PING='Ping';
    GC_TIME='Time';
    GC_LOSS='Loss';
    GC_IP='IP';
    GC_PORT='Port';
    GC_AUTHVALUE='AuthValue';
    GC_AUTHED='Authenticated';
    GC_QPORT='QPort';
    GC_LASTMSG='LastMsg';
    GC_RATE='Rate';
    GC_ONLINE='Online';

implementation
end.
