unit ScriptObject;

interface

Uses
    StringFunctions,
    Writer,
    Enviroment,
    ObjectNode,
    ssClient,
    ScreenShot,
    GameClient,
    GameServer,
    ThreadTimer,
    Variables;

Type
    TScriptObj = Class;
    TScriptList=Class(TObjectNode)
    public
        Property    Script[I:integer]: TScriptObj Read GetScript;

        // All help
        Function    Help: String; Override;

        Function    Settings: String; Override;

        // Execute a command
        Function    Run(Const Cmd, Params: TStringArray; ParamStr: String): string; Override;

        // Run scrited events
        Procedure   OnClientConnected(Client: TssClient);
        Procedure   OnClientDisconnected(Client: TssClient);
        Procedure   OnClientSystemId(Client: TssClient; SystemID: String);
        Procedure   OnClientAuthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
        Procedure   OnClientUnauthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
        Procedure   OnClientVersion(Client: TssClient; Version: String);
        Procedure   OnClientMaxPing(Client: TssClient; Ping, MaxPing: Integer);
        Procedure   OnClientConnTrackUnavailable(Client: TssClient);
        Procedure   OnClientShotCaptured(Client: TssClient; Shotinfo: TScreenShot);
        Procedure   OnClientShotDownloaded(Client: TssClient; Shotinfo: TScreenShot; Rate: Integer);
        Procedure   OnClientShotDownloadTooSlow(Client: TssClient; Rate: Integer);
        Procedure   OnClientIllegalFile(Client: TssClient; FileName: String; FileSize, WavLength: Integer; FileChecksum: String; FileDate: String);
        Procedure   OnClientA3D(Client: TssClient);
        Procedure   OnClientFileChecksum(Client: TssClient; Checksum: String);
        Procedure   OnClientProcessChecksum(Client: TssClient; Checksum: String);

        Procedure   OnPlayerAuthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
        Procedure   OnPlayerUnauthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
        Procedure   OnGameServerStatus(Server: TGameServer);

        // Called when after process scan
        Procedure   OnProcessFound(Client: TssClient; Index: Integer; Count: integer; Name: String; Size: Cardinal; Flags: Integer);
        // called after cheat scan
        Procedure   OnCheatScan(Client: TssClient; Result: Integer);

        Constructor Create;
        Destructor Destroy; Override;
    end;

    TScriptObj=Class(TObjectLeaf)
    Public

        // All help
        Function    Help: String; Override;

        Function    Settings: String; Override;

        // Execute a command
        Function    Run(Const Cmd, Params: TStringArray; ParamStr: String): string; Override;

        // Info about this object
        Function    Info: String; Override;

        Constructor create(Const filename: String; Const AScript: String);
        Destructor Destroy; Override;
    end;

Function GetScripts: TScriptList;

Implementation

end.
