Unit StringFunctions;
(**
 *  This unit contains various string functions
 **)

Interface

Type TStringArray = Array of String;
     TDataArray = Array of Byte;

// Breaks a line into words
Procedure SeparateLine(Names:String; List:TStringList; Separator:Char=' '; Quote:char='"');
// Breaks a line into words
Function Explode(Names:String; Separator:Char=' '; Quote:char='"'): TStringArray;
// Combines words into a line
Function Implode(Const Lines:TStringArray; Glue: String): String;
// Adds text at the beginning and end of lines
Function Outfit(Const Lines:TStringArray; PreLine: String=''; PostLine:String = ''):TStringArray;
// Add Indenting to lines
Function Indent(Const Lines:TStringArray; Space: Integer):TStringArray;
Function IndentStr(Text: String; Space:Integer): String;
// Trim White Space and quotes (removes them)
Function  TrimWSQuoteStr(Line:String):String;
Procedure TrimWsQuotes(Const Lines:TStringArray);
// Changes desimal byte value into nice string 1024 -> 1.0 kb
Function ByteStr(Int:Int64):String;
// Read a html-document, time out in ms
Function ReadDocument(url:String; Const timeout: Integer=500; Const UserAgent: String='Mozilla 2.0'): String;
// case insensitive Compare of two strings
Function InsensitiveCompare(S1, S2: String): Boolean;
// Remove first element of string array
Function RemoveFirst(Const Lines:TStringarray):TStringArray;
// Parses number that is surronded with [] into integer
// [4] -> 4,  [] -> -1, asdf -> -1
Function ParseSquareBracketedNumber(Str:String):integer;
// Get commandline parameters of ssReborn-application
Function CmdLineParams:TStringArray;
// Remove empty lines
Function RemoveEmptyLines(Text: String): String;
// Combine two string arrays
Function Join(Const Lines1, Lines2: TStringArray): TStringArray;
// Save to file
Function SaveFile(Const Filename:String; Const Text:String; Var Error: String): Boolean;
// Searches a substring from a set of arrays
Function Contains(Search: String; Const From: TStringArray): Boolean;
// Load a file
Function LoadFile(Const Filename:String; Var Error: String): String;
// Breaks address "12.34.56.78:1234" into ip and port
Function BreakAddress(Address:String; var IP, Port: String):Boolean;
// String Replace
Function StrRep(const Str, SearchFor, ReplaceWith:String): String;
// Fixes folder delimeter to correct OS, to / on linux and \ on windows
function FixDelimiter(FileName: String): String;
// splits line/words in a manner that is done in word wrapping
Function WordWrap(Const Line: String; MinWidth, MaxWidth: Integer): TStringArray;
// Searches for files. Example *.exe
Function FindFiles(Const Filename: String): TStringArray;
// Does wildcharacter comparasion (cheap regexp) (? and * are supported)
Function WildCompare(CompareTo,WildString:String):Boolean;

Procedure CreateStringArray(Len: Integer; Var newarray: TStringArray);

implementation
end.



