unit StringPair;

(* This unit controls pairs of strings *)
interface

Type
    TStringPairArray = Array of Array[0..1] of String;

    TCustomStringPair = Class
    public
        Function    GetPair(Name: String): String;
        Procedure   SetPair(Name: String; Value: String);

        Property    VarString[Name:String]: String Read GetPair Write SetPair;
    end;

    // Tree implementation of string pair
    // (so the list is unordered)
    TStringPairTree = Class(TCustomStringPair)
    Public
        Property  CaseSensitive: Boolean Read FCaseSensitive;
        Function  Count: Integer; 
        Function  HasName(Name: String): Boolean;
        Function  GetPair(Name: String): String;
        Function  RemovePair(Name: String): Boolean;
        Procedure SetPair(Name: String; Value: String);
        Function  GetSnapShot:TStringPairArray;
        Procedure Clear;

        Constructor Create(CaseSensitive: Boolean);
        Destructor Destroy;
    end;

    // TStrings implementation of string pair
    TStringPair = Class(TCustomStringPair)
    public
        Function  Count: Integer;
        Function  HasName(Name: String): Boolean;
        Function  GetPair(Name: String): String;
        Function  RemovePair(Name: String): Boolean;
        Function  GetName(I:Integer): String;
        Function  GetValue(I:Integer): String;
        Procedure SetPair(Name: String; Value: String);
        Function  GetSnapShot:TStringPairArray;
        Procedure Clear;

        Constructor Create(CaseSensitive: Boolean);
        Destructor Destroy;
    end;


implementation
end.


