unit SystemEvents;

interface

        Procedure   OnClientConnected(Client: TssClient);
        Procedure   OnClientDisconnected(Client: TssClient);
        Procedure   OnClientSystemId(Client: TssClient; SystemID: String);
        Procedure   OnClientAuthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
        Procedure   OnClientUnauthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
        Procedure   OnClientVersion(Client: TssClient; Version: String);
        Procedure   OnClientMaxPing(Client: TssClient; Ping, MaxPing: Integer);
        Procedure   OnClientConnTrackUnavailable(Client: TssClient);
        Procedure   OnClientShotCaptured(Client: TssClient; Shotinfo: TScreenShot);
        Procedure   OnClientShotDownloaded(Client: TssClient; Shotinfo: TScreenShot; Rate: Integer);
        Procedure   OnClientShotDownloadTooSlow(Client: TssClient; Rate: Integer);
        Procedure   OnClientIllegalFile(Client: TssClient; FileName: String; FileSize, WavLength: Integer; FileChecksum: String; FileDate: Double);
        Procedure   OnClientA3D(Client: TssClient);
        Procedure   OnClientFileChecksum(Client: TssClient; Checksum: String);
        Procedure   OnClientProcessChecksum(Client: TssClient; Checksum: String);

        Procedure   OnPlayerAuthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
        Procedure   OnPlayerUnauthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
        Procedure   OnGameServerStatus(Server: TGameServer);

        Procedure   OnTimer(Sender: TThreadTimer);

        Procedure   Initialization;
        Procedure   Finalization;        

implementation

end.
