unit Timers;

interface

Uses
Command,
Writer,
Variables,
Enviroment;

Type
    TTimerVariables=Class;

    // A Timer
    TTimeri=Class(TObjectLeaf)
    public
        Property    Variable: TTimerVariables Read GetVar;
        Property    Interval: Integer Read GetInterval Write SetInterval;
        Property    Count: Integer Read GetCount Write SetCount;
        Property    Command: String Read GetCommand Write SetCommand;
        Property    DestroyWhenDone: Boolean Read GetDestroyWhenDone Write SetDestroyWhenDone;
        // Write to log
        Procedure   Writeln(Line: String; MessageType: Integer=0); 
        // Settings
        Function    Settings: String; 
        // Info about this object
        Function    Info: String; 
        // All help
        Function    Help: String; 
        // Execute a command
        Function    Run(Const Cmd, Params: TStringArray; ParamStr: String): string; 
        // Create new timer
        Constructor Create;
        // Execute a command
        // Destroyer
        Destructor Destroy; 
    end;

    // List of timers
    TTimerList=Class(TObjectNode)
    public
        Property    Timer[I:Integer]: TTimeri Read GetTimer;
        // Execute a command
        Function    Run(Const Cmd, Params: TStringArray; ParamStr: String): string; 
        // Settings
        Function    Settings: String; 
        // Info about this object
        Function    Info: String; 
        // All help
        Function    Help: String; 
        Destructor  Destroy; 
        constructor Create;
    end;

    TTimerVariables=Class(TVariable)
    end;

Const
    TV_INTERVAL = 'Interval';
    TV_COUNT = 'RepeatCount';
    TV_COMMAND = 'Command';
    TV_DESTROYWHENDONE = 'DestroyWhenDone';

Function GetTimerList: TTimerList;

implementation
end.
