unit ssServer;

interface

Uses
    Writer,
    Variables,
    ObjectNode,
    StringPair,
    ssClient;

Type
    TssServerVariables=Class;
    TssClientArray = Array of TssClient;
    TssServer=Class(TObjectNode)
    public
        Function    GetPath:String; 
        Property    Variable: TssServerVariables Read GetVar;
        Function    GetLog: TWriterList;

        Function    ClientMinVersion: Integer;
        Function    ClientMaxVersion: Integer;
        Function    ClientDownloadVersion: Integer;

        // List acquired with GetClientList is only valid inside the script
        // function. It must not be used after the function call if over
        Function    GetClientList: TssClientArray;

        // Command that loads and caches illegal files list
        Function    LoadIllegalFiles(FileList: String): string;

        Property    Client[I:Integer]: TSSClient Read GetClient;
        Function    FindByID(Id:Integer): TssClient;
        Function    FindByName(Name: String): TssClient;
        Function    FindByIP(IP: String): TssClient;

        Function    GetHelp(Cmd: String): String; 
        Function    Help: String; 

        function    Run(Const Cmd, Params: TStringArray; ParamStr:String): string; 
        Function    Settings:String; 

        Constructor Create;
        Destructor  Destroy; 
    end;

    TssServerVariables=Class(TVariable)
        Procedure   SetPair(Name: String; Value: String); 
    end;

Const
(* Variables names *)
    SSS_SHOT_PACKETSIZE = 'ShotPacketSize';     // Packet size screen shot transfer
    SSS_SHOT_WIDTH = 'ShotWidth';               // Width of shot
    SSS_SHOT_HEIGHT = 'ShotHeight';             // Height of shot
    SSS_SHOT_COMPRESSION = 'ShotCompression';   // Compression
    SSS_SHOT_UPLOADRATE = 'ShotUploadRate';     // Target upload rate
    SSS_SHOT_MINIMUMRATE = 'ShotMinimumRate';   // Minimum upload rate
(* See ssClient.pas for more variable names *)

    SSS_DEFAULT_UPLOADRATE = 1024;
    SSS_DEFAULT_MINIMUMRATE = 256;
    SSS_DEFAULT_PACKETSIZE = 128;

Function GetssServer: TssServer;

implementation
end.
