(*
 This script scans the processes that have been loaded to the game process.
 Example: Hack HACK.DLL is loaded into the address space of a game (say Hl.exe)
 This script will enumerate cheats and ban players with hacks

 This script authenticates player by IP:Port pair. Not too secure, but because
 rcon has challenge system it is adequate.

 Create text file processes.txt

 To load this script into ssServer run:
script.test scripts/processscan.pas
script.unload hookscan
script.load hookscan scripts/processscan.pas
script.hookscan.log.add console stdout
script.hookscan.log.add file log/processscan.log
Script.hookscan.log.FileLog.TimeStamp enable
Script.hookscan.log.FileLog.TimeStampFormat "dd.MM.yy HH:mm:ss"
script.hookscan.execute processes.txt

 *)
program rconserver;

// Edit these
const BANFILENAME = 'hackbanned.cfg'; // do not use the same filename on other scripts
const SCANINTERVAL = 60*4; // scan every 4 minutes
const KICK_BANNED = true;  // The code is bit slow if there are lots of servers (and bans)
const ALLOW_IPBANS = true; // Allow IPbased bans if Steam_id is not known 
const ALLOW_IDBANS = true;  // Allow Unique ID based bans
const FULL_SCAN = true;     // Finds opengl.exe and loader.exes

const ACTION_NAG = 'NAG';
const ACTION_KICK = 'KICK';
const ACTION_BAN = 'BAN';

///////////////////////////////////////////////////////////////////////////////

Type TCheatInfo = Record
        Filename: String;
        Kick, Ban, Nag: Boolean;
        Description: String;
        MinSize, MaxSize: Integer;
        SizeSpecified: Boolean;
    end;
    TCheatInfoArray = Array of TCheatInfo;

var Timer: TThreadTimer;
    banfile: TBanFile;
    CheatList : TCheatInfoArray;

Function Explode2(Names:String; Separator:Char; Quote:char): TStringArray;
Var List:TStringList;
    I:Integer;
begin
    List := TStringList.Create;
    SeparateLine(Names, List, separator, quote);
    SetArrayLength(Result, List.count);
    For I:=0 to List.count-1 do
        Result[I] := List[I];
    List.Destroy;
end;

// Load and parse process.txt into 3 arrays : names, descriptions, actions
Procedure LoadProcessList(ProcessListFileName: String);
var Lines, Words: TStringArray;
    I, J, Count:Integer;
    Error: String;
    Text : String;
    Line, Word : String;
    CheatInfo: TCheatInfo;
    MemSize: Integer;
begin
    Error := '';
    Text := LoadFile(ProcessListFileName, Error);
    If (Error<>'') then begin
        Writeln('Error loading '+ProcessListFileName);
        exit;
    end;

    // Break the text into lines
    SetArrayLength(Lines, 0);
    Lines := Explode2(Text, #10 ,'"');

    SetArrayLength(CheatList, GetArrayLength(Lines));
    Count := 0;

    // Calculate how many lines have
    For I:=0 to GetArrayLength(Lines)-1 do begin
        Line := Lines[I];
        Line := StrRep(Line, #10, '');
        Line := StrRep(Line, #13, '');
        If (Line='') then continue;
        If WildCompare(Line, '//*') Then continue;

        Words := Explode2(Line, ' ', '"');
        if (GetArrayLength(words)<=2) then Continue;

        CheatInfo.Filename := Words[0];
        CheatInfo.Description := '';
        CheatInfo.Kick := False;
        CheatInfo.Ban := False;
        CheatInfo.Nag := False;
        MemSize := StrToInt(Words[1]);
        CheatInfo.SizeSpecified := MemSize<>0;
        CheatInfo.MinSize := (MemSize*2) div 3;
        CheatInfo.MaxSize := (MemSize*4) div 3;

        For J:=2 to GetArrayLength(words)-1 do begin
            Word := Words[J];
            If insensitiveCompare(ACTION_NAG, word) then CheatInfo.Nag := True else
            If insensitiveCompare(ACTION_BAN, word) then CheatInfo.Ban := True else
            If insensitiveCompare(ACTION_KICK, word) then CheatInfo.Kick := True else
            If CheatInfo.Description='' then
                CheatInfo.Description := word
            else
                CheatInfo.Description := CheatInfo.Description +' '+ word;
        end;
        CheatInfo.Description := TrimWSQuoteStr(CheatInfo.Description);

        CheatList[count] := CheatInfo;
        Count := Count +1;
    end;

    SetArrayLength(CheatList, Count);
    For I:=0 to GetArrayLength(CheatList)-1 do begin
        Line := CheatList[I].Filename+' "'+CheatList[I].Description+'"';
        If CheatList[I].SizeSpecified then
            Line := Line+' (Size between '+inttostr(CheatList[I].MinSize)+'-'+inttostr(CheatList[I].MaxSize)+')';
        If CheatList[I].Kick then
            Line := Line+' KICK';
        If CheatList[I].Ban then
            Line := Line+' BAN';
        If CheatList[I].Nag then
            Line := Line+' NAG';
        //Writeln(Line);
    end;
end;

Procedure Finalization;
begin
    Writeln('Unloading the script');
    SetArrayLength(CheatList, 0);
    DestroyTimer(Timer);
end;

Procedure Initialization;
begin
    SetArrayLength(CheatList, 0);

    If ParamCount=0 then begin
        Writeln('You must specify process scan file as parameter');
        exit;
    end;

    Writeln('Loading Process scan script');
    LoadProcessList(paramstr(1));

    banfile := TBanFile.create;
    banfile.load( BANFILENAME );

    Timer := CreateTimer;
    Timer.interval := 1000*SCANINTERVAL;
    Timer.enabled := True;
    Writeln('Process scan script loaded');
end;

// Do the scanning
Procedure OnTimer(Sender: TThreadTimer);
var I:Integer;
    SS: TssServer;
    SC: TssClient;
begin
    // Iterate all ssclients
    SS := GetssServer;
    For I:=0 to SS.count-1 do begin
        SC := SS.Client[I];
        // Do process scan
        SC.QueryProcesses(FULL_SCAN);
    end;
end;

Function FindCheat(Filename:String; Size: Integer; Var Cheat: TCheatInfo): Boolean;
var I:Integer;
begin
    For I:=0 to GetArrayLength(CheatList)-1 do begin
        If WildCompare(Filename, CheatList[I].Filename) then
        begin
            If CheatList[I].SizeSpecified and
              ((Size < CheatList[I].MinSize) or
               (Size > CheatList[I].MaxSize)) then continue;

            Cheat := CheatList[I];
            Result := True;
            Exit;
        end;
    end;
    Result := false;
end;

// When results come in
Procedure OnProcessFound(Client: TssClient; Index: Integer; Count: integer; Name: String; Size: Cardinal; Flags: Integer);
var I:Integer;
    Cheat: TCheatInfo;
    Player: TGameClient;
    Server: TGameServer;
    UniqueID: String;
    Error: String;
    Line: String;
    AllowIPBans, AllowIDBans: Boolean;
begin
    If not FindCheat(Name, Size, Cheat) then Exit;
    AllowIPBans:= ALLOW_IPBANS;
    AllowIDBans:= ALLOW_IDBANS;

    // Ok cheat found. what is the action
    Player := Client.GameClient;
    UniqueID := Client.Variable.VarString[SC_UNIQUEID]
    If Player=nil then Server := nil else Server := TGameServer(Player.Parent);

    if Cheat.Nag then begin
        // NAG
        Line := Name+' "'+Cheat.Description+'" hack detected on ';
        If (Player<>nil) then begin
            Line := Line+player.RealName+' ('+Player.UniqueId+') '+Client.Variable.VarString[SC_IP];
        end else begin
            Line := Line+Client.Variable.VarString[SC_IP];
        end;
        Line := Line+' Size:'+Inttostr(size);
        Writeln(Line);
        If Server<>Nil then Server.DoSay(Player.name + ' '+Cheat.Description, Error);
    end;

    if Cheat.Kick then begin
        // KICK
        If (Player<>nil) then
            Player.KickMe('Hack detected');
    end;

    if Cheat.Ban then begin
        Writeln('Banning '+name+' ('+UniqueID+') on '+Cheat.Description);
        // BAN
        // Do IP Based ban
        If ((UniqueID='') or NOT AllowIDBans) and AllowIPBans then begin
            If Banfile.FindByIp(Client.Variable.VarString[SC_IP])=nil then
            begin
                banfile.addip(Client.Variable.VarString[SC_IP], Cheat.Description, '');
                banfile.save( BANFILENAME );
            end;
        end;

            // Do UniqueID (SteamID) Based ban
        If (UniqueID<>'') and AllowIDBans then begin
            If Banfile.FindByID(UniqueId)=nil then
            begin
                banfile.addid(UniqueId, Cheat.Description + ' ' + client.Variable.VarString[SC_NAME],
                    client.Variable.VarString[SC_IP]);
                banfile.save( BANFILENAME );
            end;
        end;
    end;
end;

// check if this player is banned
Procedure OnPlayer(Player: TGameClient);
var OldBan: TBan;
begin
    // See if the player has been banned before
    OldBan := banfile.FindById(player.UniqueId);
    if OldBan=nil then
        OldBan := banfile.FindByIP(player.Variable.VarString[GC_IP]);
    if OldBan<>nil then begin
        player.KickMe('You are banned: '+oldBan.reason);
    end;
end;


Procedure OnGameServerStatus(Server: TGameServer);
var I:Integer;
    Player: TGameClient;
    KickBanned: Boolean;
begin
    KickBanned := KICK_BANNED;
    if not KickBanned then exit;
    for I:=0 to server.count-1 do
        OnPlayer( Server.GameClient[I] );
end;

begin
end.
