program test;

Procedure OnClientSystemId(Client: TssClient; SystemID: String);
begin
    Writeln('Client '+Client.name+' SystemID='+SystemID);
end;

Procedure   OnClientConnected(Client: TssClient);
begin
    Writeln('Client ('+Client.Variable.VarString[SC_IP]+') connected');
end;

Procedure   OnClientDisconnected(Client: TssClient);
begin
    Writeln('Client '+Client.name+' disconnected');
end;

Procedure   OnClientAuthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
begin
    Writeln(Client.Variable.VarString[SC_IP]+'='+Player.RealName);
end;

Procedure   OnClientUnauthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
begin
    Writeln(Player.RealName+' is unauthenticated');
end;

Procedure   OnClientVersion(Client: TssClient; Version: String);
begin
    Writeln(Client.name+' is running version '+Version);
end;

Procedure   OnClientMaxPing(Client: TssClient; Ping, MaxPing: Integer);
begin
    Writeln(Client.name+' is not responding to ping (PING='+inttostr(ping)+' MAXPING='+inttostr(maxping));
end;

Procedure   OnClientConnTrackUnavailable(Client: TssClient);
begin
    Writeln(Client.name+' Connection tracker unavailable');
end;

Procedure   OnClientShotCaptured(Client: TssClient; Shotinfo: TScreenShot);
begin
    Writeln(Client.name+' has captured a screenshot, downloading');
end;

Procedure   OnClientShotDownloaded(Client: TssClient; Shotinfo: TScreenShot; Rate: Integer);
begin
    Writeln(Client.name+' screenshot has been downloaded. Rate: '+ByteStr(Rate)+'/s');
    Client.saveshot('e:\temp\ss.jpg');
end;

Procedure   OnClientShotDownloadTooSlow(Client: TssClient; Rate: Integer);
begin
    Writeln(Client.name+' Upload is too slow. Rate: '+ByteStr(Rate)+'/s');
end;

Procedure   OnClientIllegalFile(Client: TssClient; FileName: String; FileSize, WavLength: Integer; FileChecksum: String; FileDate: String);
begin
    Writeln(Client.name+' illegal custom file '+filename+' was found');
end;

Procedure   OnClientA3D(Client: TssClient);
begin
    Writeln(Client.name+' is running A3D');
end;

Procedure   OnClientFileChecksum(Client: TssClient; Checksum: String);
begin
    Writeln(Client.name+' Filechecksum: '+checksum);
end;

Procedure   OnClientProcessChecksum(Client: TssClient; Checksum: String);
begin
    Writeln(Client.name+' Processchecksum: '+checksum);
end;

Procedure   OnPlayerAuthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
begin
    Writeln(Client.Variable.VarString[SC_IP]+'='+Player.RealName);
end;

Procedure   OnPlayerUnauthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
begin
    Writeln(Player.RealName+' is unauthenticated');
end;


Procedure   OnPlayerUnauthed(Client: TssClient; Player: TGameClient; Server: TGameServer);
begin
    If Player.Variable.VarInteger[GC_SCORE] > 5 then begin
        Server.Say(Player.RealName+' wasn''t running ssclient');
        Player.KickMe('You must run ssclient blaa blaa');
    end;
end;


Procedure   OnGameServerStatus(Server: TGameServer);
begin
    Writeln(Server.name+' has '+inttostr(Server.count)+' players');
end;

var Timer: TThreadTimer;
    TimerCounter:Integer;

    RconServer: TRconServer;

Procedure Finalization;
begin
    Writeln('Unloading the script');
    DestroyTimer(Timer);
    DestroyRconServer(RconServer);
    Timer := nil;
end;

Procedure Initialization;
begin
    Writeln('Starting timer');
    Timer := CreateTimer;
    Timer.interval := 1000;
    Timer.enabled := True;
    TimerCounter := 0;

    Writeln('Starting rcon listener');
    RconServer := CreateHLRconServer(27027,'')
    if (RconServer=nil) then Writeln('failed');
end;

Procedure OnTimer(Sender: TThreadTimer);
begin
    Writeln('Timer event');
    TimerCounter := TimerCounter +1 ;
    if TimerCounter>5 then begin
        Writeln('Stopping the timer');
        DestroyTimer(Sender);
    end;
end;

Procedure OnRConCommand(Sender: TRconServer; Password, Command, IP: String; Port: Integer; var Response: String);
begin
    Writeln('Rcon command '+Command);
    Response := 'Your command has been received. Have a nice day.';
end;

var RCon: THlRcon;
    reply: String;

var GSList: TGameServerList;
    GS: TGameServer;
    I:Integer;
begin
    Writeln('***Executing script '+paramstr(0)+'***');
    GSList := GetGameServerList;

    Writeln('Listing all game servers');
    For I:=0 to GSList.count-1 do
    begin
        GS := GSList.GameServer[I];
        Writeln(inttostr(i+1)+'. '+GS.name);
    end;
    

    (*
    Writeln('Using rcon');
    rcon := THlRcon.Create('123.123.123.123',27015);
    Writeln('rcon Created');
    if rcon.sendrcon('status', 'passwordhere', reply) then begin
        writeln('Rcon reply: '+reply);
    end;
    Rcon.free;
    *)

    // Execute a console command
    writeln(Execute('help', nil));
    Writeln('***End of script***');
end.
